<?php
/**
 * @package Sj Content Responsive Listing
 * @version 2.5.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */

defined('_JEXEC') or die;

JFactory::getLanguage()->load('com_content');

if(!class_exists('modContentResponsiveListing')){
	class modContentResponsiveListing{
		protected static $helper = null;
		public static $total = null;
		protected $categories = null;
		protected $children = array();
		protected $items = null;
		protected $params = null;
		
		public static function getList($params , $module){
			$helper = & self::getInstance();
			return $helper->_getList($params, $module);
		}
		
		protected function _getList($params, $module){
			$this->params = $params;
			$list = array();
			$retur = array();
			$source_category = $params->get('source');
			$is_ajax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
			if(!$is_ajax){
				self::$total = $this->getTotal($source_category,$params);
			}
			
			$image_config = array(
					'output_width'  => $params->get('item_image_width'),
					'output_height' => $params->get('item_image_height'),
					'function'		=> $params->get('item_image_function'),
					'background'	=> $params->get('item_image_background')
			);
			
			$catids  = $this->getCategories($source_category, $params);
			if(!empty($catids)){
				$categories = $this->getCategoriesIn($catids,$params);
				include_once JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php';
				foreach($categories as $cat){
					$category = $this->getCategory($cat, $params);
					$category->count = 0;
					$list[$category->id] = $category;
				}
				
				$retur['categories'] = $list;
				
				$items = $this->getCategoryItems($catids, $params);
				if(!empty($items)) {
					include_once JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php';
					$custom = $this->_getCustomUrl($params);
					foreach($items as $key => $item){
						$category = $this->getCategory($item->catid,$params);
						$category = $list[$item->catid];
						if(isset($category->count)){
							$category->count ++;
						}else{
							$category->count = 1;
						}
						$item->catslug = $item->catid ? $item->catid .':'.$category->alias : $item->catid;
						$item->catlink = JRoute::_( ContentHelperRoute::getCategoryRoute($item->catslug) );
						$item->category_title = $category->title;
						
						$author = JFactory::getUser($item->created_by);
						$item->author = $author->name;
						if(array_key_exists($item->id, $custom)){
							$item->link=  trim($custom[$item->id]->url);
						}else{
							$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->id, $item->catid));
						}
						$item->image = self::imageTag($item, array('image_intro', 'image_fulltext'), $image_config);
						
					}
				}
				
				if ($params->get('tab_all_display', 1)){
					$all = new stdClass();
					$all->id = '*';
					$all->count = count($items);
					$all->title = JText::_('All');
				
					array_unshift($retur['categories'], $all);
				}
				// default select
				$catidpreload = $params->get('catidpreload');
				$selected = false;
				foreach ($retur['categories'] as $cat){
					if ( $cat->id == $catidpreload && $cat->count > 0 ){
						$cat->sel = 'sel';
						$selected = true;
					}
				}
				// first tab is active
				if (!$selected){
					foreach ($retur['categories'] as $cat){
						if ($cat->count > 0){
							$cat->sel = 'sel';
							break;
						}
					}
				}
				
				$retur['items'] = $items;
				//var_dump($retur['categories']);
				return $retur;
			}
		}
		

		private function _getCustomUrl($params, $key = 'id') {
			$custom = array();
			$params_custom = $params->get('custom');
			if (isset($params_custom)){
				if (count($params_custom)){
					foreach($params_custom as $obj){
						if (is_array($obj)){
							$obj = JArrayHelper::toObject($obj);
						}
						if (isset($obj->$key) && !empty($obj->$key)){
							$custom[$obj->$key] = $obj;
						}
					}
				}
			}
			return $custom;
		}
		
		public static function imageTag($article, $types = array('image_intro', 'image_fulltext'), $resize=array()){
			$image_data = json_decode($article->images, true);
			$image_tag = null;
			$image_src = null;
			$image_alt = null;
			$image_caption = null;
			foreach($types as $type){
				if( !empty($image_data[$type]) ){
					$image_src = $image_data[$type];
					$image_alt = (isset($image_data[$type.'_alt']) && !empty($image_data[$type.'_alt'])  )? $image_data[$type.'_alt'] : $article->title;
					$image_caption = (isset($image_data[$type.'_caption']) && !empty($image_data[$type.'_caption']) )? $image_data[$type.'_caption'] : $article->title;
					$image_tag = '<img src="'. YTools::resize($image_src, $resize) .'"';
					$image_tag .= ' alt="'.htmlspecialchars($image_alt).'"';
					$image_tag .= ' title="'.$image_caption.'"';
					$image_tag .= ' />';
					break;
				}
				
			}
			
	 		if(!$image_src){
				$image_src = implode('', self::extractImages($article->introtext));
				if(file_exists($image_src)){
					$image_tag = '<img src="'. YTools::resize($image_src, $resize) .'"';
					$image_tag .= ' alt="'.$article->title.'"';
					$image_tag .= ' title="'.$article->title.'"';
					$image_tag .= ' />';
				}
			}
			
			 if (!$image_src){
				$image_src = self::getPlaceholder('mod_sj_content_reslisting');
				if(file_exists($image_src)){
					$image_tag = '<img src="'. YTools::resize($image_src, $resize) .'"';
					$image_tag .= ' alt="'.$article->title.'"';
					$image_tag .= ' title="'.$article->title.'"';
					$image_tag .= ' class="respl-nophoto"';
					$image_tag .= ' />';
				}
			}
			
			return $image_tag;
		}
	/**
	 *
	 * @param string $module_name
	 * @return string
	 */
	public static function getPlaceholder($module_name){
		return 'modules/'.$module_name.'/assets/images/nophoto.png';
	}
	
	public static function extractImages(&$text){
		$searchTags = array(
				'img' 		=> '/<img[^>]+>/i',
				'input' 	=> '/<input[^>]+type\s?=\s?"image"[^>]+>/i'
		);
		$searchSrc = '/src\s?=\s?"([^"]*)"/i';
		$images	 = array();
		foreach ($searchTags as $tag => $regex){
			preg_match_all($regex, $text, $m);
			if (count($m)){
				foreach ($m[0] as $htmltag){
					preg_match_all($searchSrc, $htmltag, $msrc);
					if (count($msrc) && isset($msrc[1])){
						foreach ($msrc[1] as $src){
							array_push($images, $src);
						}
					}
					$text = str_replace($htmltag, '', $text);
					break;
				}
			}
		}
		return $images;
	}
		
		public function getItems($ids = null){
			
			$items = array();
			if ( is_string($ids) ){
				$ids = explode(',', $ids);
			}
			if ( is_array($ids) ){
				array_map('intval', $ids);
				$ids = array_unique($ids);
				$missing = array();
		
				foreach ($ids as $id) {
					if (!isset($this->items[$id])){
						$missing[$id] = $id;
					}
				}
					
				empty($missing) OR $this->getItemsFromDb($missing, false);
				foreach ($ids as $id){
					if (isset($this->items[$id])){
						$items[$id] = $this->items[$id];
					}
				}
			}
			return $items;
		}
		
		
		public function getCategory($cid=0,$params){
			$categories = &$this->getCategoriesFromDb();
			if ( isset($categories[$cid]) ){
				return $categories[$cid];
			}
			return false;
		}
		
		public function getCategories($cids = null,$params){
			$category_ids = null;
			if (isset($cids) && !empty($cids)){
				$category_ids = $cids;
				if (is_string($category_ids)){
					$category_ids = explode(',', $category_ids);
				}
				if (!is_array($category_ids)){
					$category_ids = array($category_ids);
				}
				
				if ( !is_array($category_ids) ){
					settype($category_ids, 'array');
				}
				
				$categories = &$this->getCategoriesFromDb();
				
				foreach ($category_ids as $i => $cid) {
					if (!isset($categories[$cid])){
						unset($category_ids[$i]);
					}
				}
			}
		
			return $category_ids;
		}
		
		public function getCategoryItems($cid, $params){
			$cid = $this->getCategories($cid,$params);
			$item_ids = $this->getItemsIn($cid, $params);
			return $this->getItems($item_ids, $params);
		}
		
		public function getTotal($ids,$params){
			$ids = $this->getCategories($ids,$params);
			if (!is_array($ids)){
				$ids = array((int)$ids);
			}
			if(!empty($ids)){
				$db = &JFactory::getDbo();
				$query = "SELECT count(count_table.id) as countitems  FROM #__content AS count_table WHERE count_table.catid IN (" . implode(',', $ids)  . ") AND count_table.state IN(1)";
				$db->setQuery($query);
				$rows = $db->loadObjectList();
				$countitems = 0;
				if ( !is_null($rows) ){
					foreach($rows as $item){
						$countitems = $item->countitems;
					}
				}
				return $countitems;
			}
		}
		
		
		public function getItemsFromDb($ids, $overload = false){
			if (!is_array($ids)){
				$ids = array((int)$ids);
			}
			if(!empty($ids)){
				$db = &JFactory::getDbo();
				$query = "SELECT *  FROM #__content AS e WHERE e.id IN (" . implode(',', $ids)  . ") GROUP BY e.id;";
				$db->setQuery($query);
				$rows = $db->loadObjectList();
				$item_count = 0;
				if ( !is_null($rows) ){
					foreach($rows as $item){
						if ($overload || !isset($this->items[$item->id])){
							$this->items[$item->id] = $item;
							$item_count++;
						}
					}
				}
			
				return $item_count;
			}
		}
		
		public function getItemsIn($cids, $params){
				
			$db = &JFactory::getDbo();
			 $date = JFactory::getDate();
			$fn = (method_exists($date, 'toSql'))?'toSql':'toMySQL';
			
			$now = $date->$fn();  
			
			$nulldate = $db->getNullDate();
		
			if (isset($cids) && is_array($cids)){
				$category_filter_set = implode(',', $cids);
			}
			
			if(!empty($category_filter_set)){
				$query = "
				SELECT *
				FROM #__content as e
				WHERE
				e.state IN(1)
				AND e.catid IN ($category_filter_set)
				" . ($this->_getContentAccessFilter() ? 'AND '.$this->_getContentAccessFilter() : '') . " -- Access condition
				AND (e.publish_up   = {$db->quote($nulldate)} OR e.publish_up   <= {$db->quote($now)})
				AND (e.publish_down = {$db->quote($nulldate)} OR e.publish_down >= {$db->quote($now)})
				AND e.language IN ({$db->quote(JFactory::getLanguage()->getTag())} , {$db->quote('*')})
				{$this->_itemFilter($params)}
				GROUP BY e.id
				ORDER BY {$this->_itemOrders($params)}
				{$this->_queryLimit($params)}
				";
				
				$db->setQuery($query);
				$ids = $db->loadColumn();
				
			return $ids;
			}
		}
		
		public function getCategoriesIn($cids,$params){
			if (isset($cids) && is_array($cids)){
				$category_filter_set = implode(',', $cids);
			}
			if(!empty($category_filter_set)){
				$db = &JFactory::getDbo();
				$query = "
				SELECT *
				FROM #__categories AS e
				WHERE
				e.published IN (1)
				AND e.id IN ($category_filter_set)
				AND e.extension = 'com_content'
				AND e.parent_id > 0
				" . ($this->_getContentAccessFilter() ? 'AND '.$this->_getContentAccessFilter() : '') . " -- Access condition
						AND e.language IN ({$db->quote(JFactory::getLanguage()->getTag())} , {$db->quote('*')})
						GROUP BY e.id
						ORDER BY {$this->_catOrders($params)}
						";
						$db->setQuery($query);
						$ids = $db->loadColumn();
				return $ids;
			}
		}
		
		public function getCategoriesFromDb(){
			if (is_null($this->categories)){
				$db = &JFactory::getDbo();
				$query = "
				SELECT *
				FROM #__categories AS e
				WHERE
				e.published IN (1)
				AND e.extension = 'com_content'
				AND e.parent_id > 0
				" . ($this->_getContentAccessFilter() ? 'AND '.$this->_getContentAccessFilter() : '') . " -- Access condition
						AND e.language IN ({$db->quote(JFactory::getLanguage()->getTag())} , {$db->quote('*')})
						GROUP BY e.id
						ORDER BY e.lft
						";
				$db->setQuery($query);
				$rows = $db->loadObjectList();
				if ( !is_null($rows) ){
					$_categories = array();
					foreach($rows as $i=> $category){
						$_categories[$category->id] = &$rows[$i];
					}
					$this->categories = $_categories;
					$this->buildCategoriesTree();
				}else{
					$this->categories = array();
				}
			}
			return $this->categories;
		}
		
		protected function buildCategoriesTree(){
			$categories = &$this->getCategoriesFromDb();
			if ( count($categories) ){
				foreach ($categories as $cid => $category){
					$cid = $category->id;
					$pid = $category->parent_id;
					if (isset($categories[$pid])){
						if (!isset($this->children[$pid])){
							$this->children[$pid] = array();
						}
						$this->children[$pid][$cid] = $cid;
					}
				}
				return 1;
			}
			return 0;
		}
		
		
		protected function _getContentAccessFilter($alias='e'){
			$condition = false;
			$app  = &JFactory::getApplication();
			$params = $app->getParams();
			if ($params instanceof JRegistry && !$params->get('show_noauth', 0)){
				$user = &JFactory::getUser();
				$condition = $alias . '.access IN (' . implode(',', $user->getAuthorisedViewLevels()) . ')';
			}
			return $condition;
		}
		
		protected function _itemFilter($params, $alias='e'){
			$join_filter="";
			$source_filter = $params->get('source_filter');
			if ( isset($source_filter) ){
				// frontpage filter.
				switch ($source_filter){
					default:
					case '0':
						$join_filter = "";
						break;
					case '1':
						$join_filter = "AND $alias.featured=0";
						break;
					case '2':
						$join_filter = "AND $alias.featured=1";
						break;
				}
			}
			return $join_filter;
		}
		
		protected function _catOrders($params, $alias='e'){
			// set order by default
			$cat_order_by = "$alias.title";
			$source_order_by = $params->get('category_ordering');
			if ( isset($source_order_by) ){
				switch ($source_order_by){
					default:
					case 'title':
						$cat_order_by = "$alias.title";
						break;
					case 'lft':
						$cat_order_by = "$alias.lft ASC";
						break;
				}
			}
			//var_dump($cat_order_by);
			return $cat_order_by;
		}
		
		
		protected function _itemOrders($params, $alias='e'){
			// set order by default
			$item_order_by = "$alias.title";
			$source_order_by = $params->get('source_order_by');
			if ( isset($source_order_by) ){
				$string_order_by = trim($source_order_by);
				switch ($string_order_by){
					default:
					case 'title':
						$item_order_by = "$alias.title";
						break;
					case 'ordering':
						$item_order_by = "$alias.ordering";
					break;
					case 'mostview':
					case 'hits':
						$item_order_by = "$alias.hits DESC";
						break;
					case 'recently_add':
					case 'created':
						$item_order_by = "$alias.created DESC";
						break;
					case 'recently_mod':
					case 'modified':
						$item_order_by = "$alias.modified DESC";
						break;
					case 'random':
						$item_order_by = 'rand()';
						break;
				}
			}
			return $item_order_by;
		}
		
		protected function _queryLimit($params){
			$app = JFactory::getApplication();
			$appParams = $app->getParams();
			$source_limit = '';
			$limitation = $params->get('source_limit');
			if (isset($limitation) && (int)$limitation>=0){
				
				$source_limit_total = (int)$limitation;
				$source_limit = 'LIMIT '. $app->input->getInt('ajax_reslisting_start',0).','. $source_limit_total;
			}
			return $source_limit;
		}
		
		public static function getInstance(){
			if(is_null(self::$helper)){
				$classname = __CLASS__;
				self::$helper = new $classname;
			}
			return self::$helper;
		}
	}
}
